## libv8 3.1.8.22

=== SConstruct ===
# Copyright 2010 the V8 project authors. All rights reserved.
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#     * Neither the name of Google Inc. nor the names of its
#       contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import platform
import re
import sys
import os
from os.path import join, dirname, abspath
from types import DictType, StringTypes
root_dir = dirname(File('SConstruct').rfile().abspath)
sys.path.insert(0, join(root_dir, 'tools'))
import js2c, utils

# ANDROID_TOP is the top of the Android checkout, fetched from the environment
# variable 'TOP'.   You will also need to set the CXX, CC, AR and RANLIB
# environment variables to the cross-compiling tools.
ANDROID_TOP = os.environ.get('TOP')
if ANDROID_TOP is None:
  ANDROID_TOP=""

# ARM_TARGET_LIB is the path to the dynamic library to use on the target
# machine if cross-compiling to an arm machine. You will also need to set
# the additional cross-compiling environment variables to the cross compiler.
ARM_TARGET_LIB = os.environ.get('ARM_TARGET_LIB')
if ARM_TARGET_LIB:
  ARM_LINK_FLAGS = ['-Wl,-rpath=' + ARM_TARGET_LIB + '/lib:' +
                     ARM_TARGET_LIB + '/usr/lib',
                    '-Wl,--dynamic-linker=' + ARM_TARGET_LIB +
                    '/lib/ld-linux.so.3']
else:
  ARM_LINK_FLAGS = []

GCC_EXTRA_CCFLAGS = []
GCC_DTOA_EXTRA_CCFLAGS = []

ANDROID_FLAGS = ['-march=armv7-a',
                 '-mtune=cortex-a8',
                 '-mfloat-abi=softfp',
                 '-mfpu=vfp',
                 '-fpic',
                 '-mthumb-interwork',
                 '-funwind-tables',
                 '-fstack-protector',
                 '-fno-short-enums',
                 '-fmessage-length=0',
                 '-finline-functions',
                 '-fno-inline-functions-called-once',
                 '-fgcse-after-reload',
                 '-frerun-cse-after-loop',
                 '-frename-registers',
                 '-fomit-frame-pointer',
                 '-finline-limit=64',
                 '-DCAN_USE_VFP_INSTRUCTIONS=1',
                 '-DCAN_USE_ARMV7_INSTRUCTIONS=1',
                 '-DCAN_USE_UNALIGNED_ACCESSES=1',
                 '-MD']

ANDROID_INCLUDES = [ANDROID_TOP + '/bionic/libc/arch-arm/include',
                    ANDROID_TOP + '/bionic/libc/include',
                    ANDROID_TOP + '/bionic/libstdc++/include',
                    ANDROID_TOP + '/bionic/libc/kernel/common',
                    ANDROID_TOP + '/bionic/libc/kernel/arch-arm',
                    ANDROID_TOP + '/bionic/libm/include',
                    ANDROID_TOP + '/bionic/libm/include/arch/arm',
                    ANDROID_TOP + '/bionic/libthread_db/include',
                    ANDROID_TOP + '/frameworks/base/include',
                    ANDROID_TOP + '/system/core/include']

ANDROID_LINKFLAGS = ['-nostdlib',
                     '-Bdynamic',
                     '-Wl,-T,' + ANDROID_TOP + '/build/core/armelf.x',
                     '-Wl,-dynamic-linker,/system/bin/linker',
                     '-Wl,--gc-sections',
                     '-Wl,-z,nocopyreloc',
                     '-Wl,-rpath-link=' + ANDROID_TOP + '/out/target/product/generic/obj/lib',
                     ANDROID_TOP + '/out/target/product/generic/obj/lib/crtbegin_dynamic.o',
                     ANDROID_TOP + '/prebuilt/linux-x86/toolchain/arm-eabi-4.4.0/lib/gcc/arm-eabi/4.4.0/interwork/libgcc.a',
                     ANDROID_TOP + '/out/target/product/generic/obj/lib/crtend_android.o'];

LIBRARY_FLAGS = {
  'all': {
    'CPPPATH': [join(root_dir, 'src')],
    'regexp:interpreted': {
      'CPPDEFINES': ['V8_INTERPRETED_REGEXP']
    },
    'mode:debug': {
      'CPPDEFINES': ['V8_ENABLE_CHECKS', 'OBJECT_PRINT']
    },
    'vmstate:on': {
      'CPPDEFINES':   ['ENABLE_VMSTATE_TRACKING'],
    },
    'objectprint:on': {
      'CPPDEFINES':   ['OBJECT_PRINT'],
    },
    'protectheap:on': {
      'CPPDEFINES':   ['ENABLE_VMSTATE_TRACKING', 'ENABLE_HEAP_PROTECTION'],
    },
    'profilingsupport:on': {
      'CPPDEFINES':   ['ENABLE_VMSTATE_TRACKING', 'ENABLE_LOGGING_AND_PROFILING'],
    },
    'debuggersupport:on': {
      'CPPDEFINES':   ['ENABLE_DEBUGGER_SUPPORT'],
    },
    'inspector:on': {
      'CPPDEFINES':   ['INSPECTOR'],
    },
    'liveobjectlist:on': {
      'CPPDEFINES':   ['ENABLE_DEBUGGER_SUPPORT', 'INSPECTOR',
                       'LIVE_OBJECT_LIST', 'OBJECT_PRINT'],
    }
  },
  'gcc': {
    'all': {
      'CCFLAGS':      ['$DIALECTFLAGS', '$WARNINGFLAGS'],
      'CXXFLAGS':     ['$CCFLAGS', '-fno-rtti', '-fno-exceptions'],
    },
    'visibility:hidden': {
      # Use visibility=default to disable this.
      'CXXFLAGS':     ['-fvisibility=hidden']
    },
    'mode:debug': {
      'CCFLAGS':      ['-g', '-O0'],
      'CPPDEFINES':   ['ENABLE_DISASSEMBLER', 'DEBUG'],
      'os:android': {
        'CCFLAGS':    ['-mthumb']
      }
    },
    'mode:release': {
      'CCFLAGS':      ['-O3', '-fomit-frame-pointer', '-fdata-sections',
                       '-ffunction-sections'],
      'os:android': {
        'CCFLAGS':    ['-mthumb', '-Os'],
        'CPPDEFINES': ['SK_RELEASE', 'NDEBUG']
      }
    },
    'os:linux': {
      'CCFLAGS':      ['-ansi'] + GCC_EXTRA_CCFLAGS,
      'library:shared': {
        'CPPDEFINES': ['V8_SHARED'],
        'LIBS': ['pthread']
      }
    },
    'os:macos': {
      'CCFLAGS':      ['-ansi', '-mmacosx-version-min=10.4'],
      'library:shared': {
        'CPPDEFINES': ['V8_SHARED']
      }
    },
    'os:freebsd': {
      'CPPPATH' : ['/usr/local/include'],
      'LIBPATH' : ['/usr/local/lib'],
      'CCFLAGS':      ['-ansi'],
    },
    'os:openbsd': {
      'CPPPATH' : ['/usr/local/include'],
      'LIBPATH' : ['/usr/local/lib'],
      'CCFLAGS':      ['-ansi'],
    },
    'os:solaris': {
      # On Solaris, to get isinf, INFINITY, fpclassify and other macros one
      # needs to define __C99FEATURES__.
      'CPPDEFINES': ['__C99FEATURES__'],
      'CPPPATH' : ['/usr/local/include'],
      'LIBPATH' : ['/usr/local/lib'],
      'CCFLAGS':      ['-ansi'],
    },
    'os:win32': {
      'CCFLAGS':      ['-DWIN32'],
      'CXXFLAGS':     ['-DWIN32'],
    },
    'os:android': {
      'CPPDEFINES':   ['ANDROID', '__ARM_ARCH_5__', '__ARM_ARCH_5T__',
                       '__ARM_ARCH_5E__', '__ARM_ARCH_5TE__'],
      'CCFLAGS':      ANDROID_FLAGS,
      'WARNINGFLAGS': ['-Wall', '-Wno-unused', '-Werror=return-type',
                       '-Wstrict-aliasing=2'],
      'CPPPATH':      ANDROID_INCLUDES,
    },
    'arch:ia32': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_IA32'],
      'CCFLAGS':      ['-m32'],
      'LINKFLAGS':    ['-m32']
    },
    'arch:arm': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_ARM'],
      'unalignedaccesses:on' : {
        'CPPDEFINES' : ['CAN_USE_UNALIGNED_ACCESSES=1']
      },
      'unalignedaccesses:off' : {
        'CPPDEFINES' : ['CAN_USE_UNALIGNED_ACCESSES=0']
      }
    },
    'simulator:arm': {
      'CCFLAGS':      ['-m32'],
      'LINKFLAGS':    ['-m32'],
    },
    'arch:mips': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_MIPS'],
      'simulator:none': {
        'CCFLAGS':      ['-EL', '-mips32r2', '-Wa,-mips32r2', '-fno-inline'],
        'LDFLAGS':      ['-EL']
      }
    },
    'simulator:mips': {
      'CCFLAGS':      ['-m32'],
      'LINKFLAGS':    ['-m32'],
    },
    'arch:x64': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_X64'],
      'CCFLAGS':      ['-m64'],
      'LINKFLAGS':    ['-m64'],
    },
    'gdbjit:on': {
      'CPPDEFINES':   ['ENABLE_GDB_JIT_INTERFACE']
    }
  },
  'msvc': {
    'all': {
      'CCFLAGS':      ['$DIALECTFLAGS', '$WARNINGFLAGS'],
      'CXXFLAGS':     ['$CCFLAGS', '/GR-', '/Gy'],
      'CPPDEFINES':   ['WIN32'],
      'LINKFLAGS':    ['/INCREMENTAL:NO', '/NXCOMPAT', '/IGNORE:4221'],
      'CCPDBFLAGS':   ['/Zi']
    },
    'verbose:off': {
      'DIALECTFLAGS': ['/nologo'],
      'ARFLAGS':      ['/NOLOGO']
    },
    'arch:ia32': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_IA32', '_USE_32BIT_TIME_T'],
      'LINKFLAGS':    ['/MACHINE:X86'],
      'ARFLAGS':      ['/MACHINE:X86']
    },
    'arch:x64': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_X64'],
      'LINKFLAGS':    ['/MACHINE:X64'],
      'ARFLAGS':      ['/MACHINE:X64']
    },
    'mode:debug': {
      'CCFLAGS':      ['/Od', '/Gm'],
      'CPPDEFINES':   ['_DEBUG', 'ENABLE_DISASSEMBLER', 'DEBUG'],
      'LINKFLAGS':    ['/DEBUG'],
      'msvcrt:static': {
        'CCFLAGS': ['/MTd']
      },
      'msvcrt:shared': {
        'CCFLAGS': ['/MDd']
      }
    },
    'mode:release': {
      'CCFLAGS':      ['/O2'],
      'LINKFLAGS':    ['/OPT:REF', '/OPT:ICF'],
      'msvcrt:static': {
        'CCFLAGS': ['/MT']
      },
      'msvcrt:shared': {
        'CCFLAGS': ['/MD']
      },
      'msvcltcg:on': {
        'CCFLAGS':      ['/GL'],
        'ARFLAGS':      ['/LTCG'],
        'pgo:off': {
          'LINKFLAGS':    ['/LTCG'],
        },
        'pgo:instrument': {
          'LINKFLAGS':    ['/LTCG:PGI']
        },
        'pgo:optimize': {
          'LINKFLAGS':    ['/LTCG:PGO']
        }
      }
    }
  }
}


V8_EXTRA_FLAGS = {
  'gcc': {
    'all': {
      'WARNINGFLAGS': ['-Wall',
                       '-Werror',
                       '-W',
                       '-Wno-unused-parameter',
                       '-Wnon-virtual-dtor']
    },
    'os:win32': {
      'WARNINGFLAGS': ['-pedantic', '-Wno-long-long']
    },
    'os:linux': {
      'WARNINGFLAGS': ['-pedantic'],
      'library:shared': {
        'soname:on': {
          'LINKFLAGS': ['-Wl,-soname,${SONAME}']
        }
      }
    },
    'os:macos': {
      'WARNINGFLAGS': ['-pedantic']
    },
    'disassembler:on': {
      'CPPDEFINES':   ['ENABLE_DISASSEMBLER']
    }
  },
  'msvc': {
    'all': {
      'WARNINGFLAGS': ['/W3', '/WX', '/wd4351', '/wd4355', '/wd4800']
    },
    'library:shared': {
      'CPPDEFINES': ['BUILDING_V8_SHARED'],
      'LIBS': ['winmm', 'ws2_32']
    },
    'arch:arm': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_ARM'],
      # /wd4996 is to silence the warning about sscanf
      # used by the arm simulator.
      'WARNINGFLAGS': ['/wd4996']
    },
    'arch:mips': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_MIPS'],
    },
    'disassembler:on': {
      'CPPDEFINES':   ['ENABLE_DISASSEMBLER']
    }
  }
}


MKSNAPSHOT_EXTRA_FLAGS = {
  'gcc': {
    'os:linux': {
      'LIBS': ['pthread'],
    },
    'os:macos': {
      'LIBS': ['pthread'],
    },
    'os:freebsd': {
      'LIBS': ['execinfo', 'pthread']
    },
    'os:solaris': {
      'LIBS': ['m', 'pthread', 'socket', 'nsl', 'rt'],
      'LINKFLAGS': ['-mt']
    },
    'os:openbsd': {

=== debian/changelog ===
libv8 (3.1.8.22-1ubuntu2) oneiric; urgency=low

  * Backport timeout bump from 3.4.14.21-1:
    "Tests timeout after 120 seconds, instead of 60.
     Some builders can have slower machines."
    Fixes FTBFS. (LP: #852605)

 -- Daniel T Chen <crimsun@ubuntu.com>  Tue, 27 Sep 2011 09:14:07 -0400

libv8 (3.1.8.22-1ubuntu1) oneiric; urgency=low

  * Build with -Wno-error=unused-but-set-variable. LP: #831141.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 14 Sep 2011 23:13:43 +0000

libv8 (3.1.8.22-1) unstable; urgency=low

  [ Jérémy Lal ]
  * Enable i18n experimental extension. Build-Depends on libicu-dev.
    Closes: bug#627066. Thanks to Giuseppe Iuculano.
  * Stop special-casing some regression tests on armel (introduced in
    3.1.8.10-2): Solved by disabling cctests (since 3.1.8.10-3).

  [ Jonas Smedegaard ]
  * Unfuzz patches.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 20 Jun 2011 22:24:02 +0200

libv8 (3.1.8.10-3) unstable; urgency=low

  * Disable cctests : they fail from time to time and are meant
    to be used for upstream development purposes. Only javascript
    tests are run.

 -- Jérémy Lal <kapouer@melix.org>  Sat, 23 Apr 2011 13:47:42 +0200

libv8 (3.1.8.10-2) unstable; urgency=low

  * Temporarily allow some tests to fail on armel builds.
    Closes: bug#623449.
  * Turn on verbose output when running tests. 

 -- Jérémy Lal <kapouer@melix.org>  Fri, 22 Apr 2011 16:51:10 +0200

libv8 (3.1.8.10-1) unstable; urgency=low

  [ Jérémy Lal ]
  * New upstream release. 

  [ Jonas Smedegaard ]
  * Bump policy compliance to standards-version 3.9.2.
  * Bump copyright file format to draft 174 of DEP-5.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 16 Apr 2011 12:59:59 +0200

libv8 (2.5.9.21-1) unstable; urgency=low

  * New upstream release.

  [ Jérémy Lal ]
  * Relax regression checking to not cause build to fail.
  * Use DEB_SCONS_ENVVARS to define SONAME, removing the need for the
    soname patch, and allowing builds with gold linker. 

  [ Jonas Smedegaard ]
  * Only relax regression checking when targeted experimental.
  * Let CDBS auto-resolve build-dependencies and library package name.
  * Fix tighten build-dependencies on cdbs and debhelper.
  * Build-depend on dh-buildinfo.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 29 Mar 2011 12:41:52 +0200

libv8 (2.5.9.16-1) unstable; urgency=low

  * New upstream release.

  [ Jérémy Lal ]
  * Add architecture armhf.
    Closes: #596997

  [ Jonas Smedegaard ]
  * Rewrite copyright file using draft svn166 of DEP5 format.
  * Supress copyright-checking a few binary files, to not upset
    dpkg-source.

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 24 Feb 2011 16:51:54 +0100

libv8 (2.5.9.15-2) unstable; urgency=low

  * Builds with snapshot=on. (Closes: #612781) 

 -- Jérémy Lal <kapouer@melix.org>  Sat, 12 Feb 2011 02:27:40 +0100

libv8 (2.5.9.15-1) unstable; urgency=low

  * New upstream release.

  [ Jérémy Lal ]
  * Map DEB_HOST_ARCH and DEB_HOST_ARCH_OS to v8 scons options 'arch'
    and 'os'. (Closes: #611215)
    Move to team-maintainance, with me as maintainer and Jonas
    Smedegaard as uploader.
    Drop Antonio Radici as uploader: Thanks for your contributions,
    Antonio!

  [ Jonas Smedegaard ]
  * Tidy CDBS variables internally in rules file.

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 07 Feb 2011 01:36:39 +0100

=== debian/control ===
Source: libv8
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Jérémy Lal <kapouer@melix.org>,
 Jonas Smedegaard <dr@jones.dk>
Build-Depends: devscripts (>= 2.10.7~),
 scons,
 cdbs (>= 0.4.85~),
 debhelper (>= 7.0.1),
 dh-buildinfo, libicu-dev
Standards-Version: 3.9.2
Section: libs
Homepage: http://code.google.com/p/v8/
DM-Upload-Allowed: yes
Vcs-Browser: http://git.debian.org/?p=collab-maint/libv8.git
Vcs-Git: git://git.debian.org/git/collab-maint/libv8.git

Package: libv8-dev
Section: libdevel
Architecture: i386 amd64 armel armhf
Depends: libv8-3.1.8.22 (= ${binary:Version}), ${misc:Depends}
Description: Development files for the V8 JavaScript Engine
 V8 is Google's open source, high performance JavaScript engine. It is written
 in C++ and is used in Google Chrome, Google's open source browser.
 .
 Install this package if you wish to develop your own programs using the
 V8 JavaScript Engine

Package: libv8-3.1.8.22
Architecture: i386 amd64 armel armhf
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: V8 JavaScript Engine
 V8 is Google's open source, high performance JavaScript engine. It is written
 in C++ and is used in Google Chrome, Google's open source browser.
 .
 This package includes the dynamic library against which you can link your
 program.

Package: libv8-dbg
Priority: extra
Section: debug
Architecture: i386 amd64 armel armhf
Depends: libv8-3.1.8.22 (= ${binary:Version}), ${misc:Depends}
Description: Debugging symbols for the V8 JavaScript Engine
 V8 is Google's open source, high performance JavaScript engine. It is written
 in C++ and is used in Google Chrome, Google's open source browser.
 .
 This package provides the debugging symbols for the library.

=== debian/rules ===
#!/usr/bin/make -f

# This needs to run before inclusion of CDBS snippets
debian/control:: debian/control.in
DEB_PHONY_RULES += debian/control.in
debian/control.in::
	sed -e 's/__LIBPKGNAME__/$(LIBPKGNAME)/g' <debian/control.in.in >debian/control.in

include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/class/scons.mk
include /usr/share/cdbs/1/rules/debhelper.mk

SONAME = $(DEB_UPSTREAM_VERSION)
LIBPKGNAME = libv8-$(SONAME)

# suppress checking binary files, to not upset dpkg-source
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^(benchmarks/v8-logo\.png|test/mjsunit/unicode-test\.js|debian/(changelog|copyright(|_hints|_newhints)))$

DEB_DH_MAKESHLIBS_ARGS = -- -c4

CXXFLAGS += -fno-strict-aliasing -Wno-error=unused-but-set-variable
CFLAGS += -fno-strict-aliasing -Wno-error=unused-but-set-variable
export CFLAGS
export CXXFLAGS

# map HOST ARCH AND OS to v8 options
v8arch := $(or $(v8arch),$(if $(filter i386,$(DEB_HOST_ARCH)),ia32))
v8arch := $(or $(v8arch),$(if $(filter amd64,$(DEB_HOST_ARCH)),x64))
v8arch := $(or $(v8arch),$(if $(filter armel,$(DEB_HOST_ARCH)),arm))
v8arch := $(or $(v8arch),$(if $(filter armhf,$(DEB_HOST_ARCH)),arm))
v8arch := $(or $(v8arch),$(if $(filter mipsel,$(DEB_HOST_ARCH)),mips))
v8arch := $(or $(v8arch),$(DEB_HOST_ARCH))
v8os := $(or $(v8os),$(if $(filter linux,$(DEB_HOST_ARCH_OS)),linux))
v8os := $(or $(v8os),$(if $(filter kfreebsd,$(DEB_HOST_ARCH_OS)),freebsd))
v8os := $(or $(v8os),$(DEB_HOST_ARCH_OS))

DEB_SCONS_OPTIONS = library=shared soname=on snapshot=on shlibtype=hidden arch=$(v8arch) os=$(v8os)
DEB_SCONS_BUILD_TARGET = library

# Scons does not always add -soname param, force it. This prevents gold linker from erroring.
DEB_SCONS_ENVVARS = SONAME=libv8.so.$(SONAME)

# regression tests need to build shell for mjsunit
DEB_SCONS_CHECK_TARGET = sample sample=shell

DEB_SCONS_INSTALL_OPTIONS += DESTDIR="$(cdbs_curdestdir)"

DEB_DH_INSTALL_ARGS_$(LIBPKGNAME) = usr/lib/libv8.so.$(SONAME)

clean::
	rm -f tools/*.pyc libv8-$(SONAME).so
	rm -rf obj
	rm -f test/*/*.pyc
	rm -f shell

# actually run regression tests
#  * relax regression tests when targeted experimental suite
#  * run only javascript tests, cctests are for development purposes
exp-relax-check := $(if $(shell dpkg-parsechangelog | grep -Fx 'Distribution: experimental'),-)
common-post-build-impl::
	$(exp-relax-check)$(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),,LD_PRELOAD=$(CURDIR)/libv8-$(SONAME).so $(CURDIR)/tools/test.py --progress=verbose --snapshot --no-build --timeout=120 mjsunit message arch=$(v8arch))

common-install-impl::
	cd debian/tmp/usr/lib/ ; \
	mv libv8-$(SONAME)*.so libv8.so.$(SONAME) ; \
	ln -s -T libv8.so.$(SONAME) libv8.so

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

# unfortunately there is no way we can download from an
# SVN tag but the watch file will still useful to find
# new versions
opts="dversionmangle=s/\+dfsg//" \
http://v8.googlecode.com/svn/tags/ (3\.1\.[\d.]+)/

## libv8 3.4.14.21

=== SConstruct ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright 2010 the V8 project authors. All rights reserved.
+# Copyright 2011 the V8 project authors. All rights reserved.
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are
 # met:
@@ -27,6 +27,7 @@
 
 import platform
 import re
+import subprocess
 import sys
 import os
 from os.path import join, dirname, abspath
@@ -34,13 +35,6 @@
 root_dir = dirname(File('SConstruct').rfile().abspath)
 sys.path.insert(0, join(root_dir, 'tools'))
 import js2c, utils
-
-# ANDROID_TOP is the top of the Android checkout, fetched from the environment
-# variable 'TOP'.   You will also need to set the CXX, CC, AR and RANLIB
-# environment variables to the cross-compiling tools.
-ANDROID_TOP = os.environ.get('TOP')
-if ANDROID_TOP is None:
-  ANDROID_TOP=""
 
 # ARM_TARGET_LIB is the path to the dynamic library to use on the target
 # machine if cross-compiling to an arm machine. You will also need to set
@@ -57,50 +51,6 @@
 GCC_EXTRA_CCFLAGS = []
 GCC_DTOA_EXTRA_CCFLAGS = []
 
-ANDROID_FLAGS = ['-march=armv7-a',
-                 '-mtune=cortex-a8',
-                 '-mfloat-abi=softfp',
-                 '-mfpu=vfp',
-                 '-fpic',
-                 '-mthumb-interwork',
-                 '-funwind-tables',
-                 '-fstack-protector',
-                 '-fno-short-enums',
-                 '-fmessage-length=0',
-                 '-finline-functions',
-                 '-fno-inline-functions-called-once',
-                 '-fgcse-after-reload',
-                 '-frerun-cse-after-loop',
-                 '-frename-registers',
-                 '-fomit-frame-pointer',
-                 '-finline-limit=64',
-                 '-DCAN_USE_VFP_INSTRUCTIONS=1',
-                 '-DCAN_USE_ARMV7_INSTRUCTIONS=1',
-                 '-DCAN_USE_UNALIGNED_ACCESSES=1',
-                 '-MD']
-
-ANDROID_INCLUDES = [ANDROID_TOP + '/bionic/libc/arch-arm/include',
-                    ANDROID_TOP + '/bionic/libc/include',
-                    ANDROID_TOP + '/bionic/libstdc++/include',
-                    ANDROID_TOP + '/bionic/libc/kernel/common',
-                    ANDROID_TOP + '/bionic/libc/kernel/arch-arm',
-                    ANDROID_TOP + '/bionic/libm/include',
-                    ANDROID_TOP + '/bionic/libm/include/arch/arm',
-                    ANDROID_TOP + '/bionic/libthread_db/include',
-                    ANDROID_TOP + '/frameworks/base/include',
-                    ANDROID_TOP + '/system/core/include']
-
-ANDROID_LINKFLAGS = ['-nostdlib',
-                     '-Bdynamic',
-                     '-Wl,-T,' + ANDROID_TOP + '/build/core/armelf.x',
-                     '-Wl,-dynamic-linker,/system/bin/linker',
-                     '-Wl,--gc-sections',
-                     '-Wl,-z,nocopyreloc',
-                     '-Wl,-rpath-link=' + ANDROID_TOP + '/out/target/product/generic/obj/lib',
-                     ANDROID_TOP + '/out/target/product/generic/obj/lib/crtbegin_dynamic.o',
-                     ANDROID_TOP + '/prebuilt/linux-x86/toolchain/arm-eabi-4.4.0/lib/gcc/arm-eabi/4.4.0/interwork/libgcc.a',
-                     ANDROID_TOP + '/out/target/product/generic/obj/lib/crtend_android.o'];
-
 LIBRARY_FLAGS = {
   'all': {
     'CPPPATH': [join(root_dir, 'src')],
@@ -110,23 +60,17 @@
     'mode:debug': {
       'CPPDEFINES': ['V8_ENABLE_CHECKS', 'OBJECT_PRINT']
     },
-    'vmstate:on': {
-      'CPPDEFINES':   ['ENABLE_VMSTATE_TRACKING'],
-    },
     'objectprint:on': {
       'CPPDEFINES':   ['OBJECT_PRINT'],
     },
-    'protectheap:on': {
-      'CPPDEFINES':   ['ENABLE_VMSTATE_TRACKING', 'ENABLE_HEAP_PROTECTION'],
-    },
-    'profilingsupport:on': {
-      'CPPDEFINES':   ['ENABLE_VMSTATE_TRACKING', 'ENABLE_LOGGING_AND_PROFILING'],
-    },
     'debuggersupport:on': {
       'CPPDEFINES':   ['ENABLE_DEBUGGER_SUPPORT'],
     },
     'inspector:on': {
       'CPPDEFINES':   ['INSPECTOR'],
+    },
+    'fasttls:off': {
+      'CPPDEFINES':   ['V8_NO_FAST_TLS'],
     },
     'liveobjectlist:on': {
       'CPPDEFINES':   ['ENABLE_DEBUGGER_SUPPORT', 'INSPECTOR',
@@ -136,26 +80,22 @@
   'gcc': {
     'all': {
       'CCFLAGS':      ['$DIALECTFLAGS', '$WARNINGFLAGS'],
-      'CXXFLAGS':     ['$CCFLAGS', '-fno-rtti', '-fno-exceptions'],
+      'CXXFLAGS':     ['-fno-rtti', '-fno-exceptions'],
     },
     'visibility:hidden': {
       # Use visibility=default to disable this.
       'CXXFLAGS':     ['-fvisibility=hidden']
     },
+    'strictaliasing:off': {
+      'CCFLAGS':      ['-fno-strict-aliasing']
+    },
     'mode:debug': {
       'CCFLAGS':      ['-g', '-O0'],
       'CPPDEFINES':   ['ENABLE_DISASSEMBLER', 'DEBUG'],
-      'os:android': {
-        'CCFLAGS':    ['-mthumb']
-      }
     },
     'mode:release': {
       'CCFLAGS':      ['-O3', '-fomit-frame-pointer', '-fdata-sections',
                        '-ffunction-sections'],
-      'os:android': {
-        'CCFLAGS':    ['-mthumb', '-Os'],
-        'CPPDEFINES': ['SK_RELEASE', 'NDEBUG']
-      }
     },
     'os:linux': {
       'CCFLAGS':      ['-ansi'] + GCC_EXTRA_CCFLAGS,
@@ -174,6 +114,7 @@
       'CPPPATH' : ['/usr/local/include'],
       'LIBPATH' : ['/usr/local/lib'],
       'CCFLAGS':      ['-ansi'],
+      'LIBS': ['execinfo']
     },
     'os:openbsd': {
       'CPPPATH' : ['/usr/local/include'],
@@ -192,14 +133,6 @@
       'CCFLAGS':      ['-DWIN32'],
       'CXXFLAGS':     ['-DWIN32'],
     },
-    'os:android': {
-      'CPPDEFINES':   ['ANDROID', '__ARM_ARCH_5__', '__ARM_ARCH_5T__',
-                       '__ARM_ARCH_5E__', '__ARM_ARCH_5TE__'],
-      'CCFLAGS':      ANDROID_FLAGS,
-      'WARNINGFLAGS': ['-Wall', '-Wno-unused', '-Werror=return-type',
-                       '-Wstrict-aliasing=2'],
-      'CPPPATH':      ANDROID_INCLUDES,
-    },
     'arch:ia32': {
       'CPPDEFINES':   ['V8_TARGET_ARCH_IA32'],
       'CCFLAGS':      ['-m32'],
@@ -212,6 +145,24 @@
       },
       'unalignedaccesses:off' : {
         'CPPDEFINES' : ['CAN_USE_UNALIGNED_ACCESSES=0']
+      },
+      'armeabi:soft' : {
+        'CPPDEFINES' : ['USE_EABI_HARDFLOAT=0'],
+        'simulator:none': {
+          'CCFLAGS':     ['-mfloat-abi=soft'],
+        }
+      },
+      'armeabi:softfp' : {
+        'CPPDEFINES' : ['USE_EABI_HARDFLOAT=0', 'CAN_USE_VFP_INSTRUCTIONS'],
+        'simulator:none': {
+          'CCFLAGS':     ['-mfloat-abi=softfp'],
+        }
+      },
+      'armeabi:hard' : {
+        'CPPDEFINES' : ['USE_EABI_HARDFLOAT=1', 'CAN_USE_VFP_INSTRUCTIONS'],
+        'simulator:none': {
+          'CCFLAGS':     ['-mfloat-abi=hard'],
+        }
       }
     },
     'simulator:arm': {
@@ -220,14 +171,40 @@
     },
     'arch:mips': {
       'CPPDEFINES':   ['V8_TARGET_ARCH_MIPS'],
+      'mips_arch_variant:mips32r2': {
+        'CPPDEFINES':    ['_MIPS_ARCH_MIPS32R2']
+      },
       'simulator:none': {
-        'CCFLAGS':      ['-EL', '-mips32r2', '-Wa,-mips32r2', '-fno-inline'],
-        'LDFLAGS':      ['-EL']
+        'CCFLAGS':      ['-EL'],
+        'LINKFLAGS':    ['-EL'],
+        'mips_arch_variant:mips32r2': {
+          'CCFLAGS':      ['-mips32r2', '-Wa,-mips32r2']
+        },
+        'mips_arch_variant:mips32r1': {
+          'CCFLAGS':      ['-mips32', '-Wa,-mips32']
+        },
+        'library:static': {
+          'LINKFLAGS':    ['-static', '-static-libgcc']
+        },
+        'mipsabi:softfloat': {
+          'CCFLAGS':      ['-msoft-float'],
+          'LINKFLAGS':    ['-msoft-float']
+        },
+        'mipsabi:hardfloat': {
+          'CCFLAGS':      ['-mhard-float'],
+          'LINKFLAGS':    ['-mhard-float']
+        }
       }
     },
     'simulator:mips': {
       'CCFLAGS':      ['-m32'],
       'LINKFLAGS':    ['-m32'],
+      'mipsabi:softfloat': {
+        'CPPDEFINES':    ['__mips_soft_float=1'],
+      },
+      'mipsabi:hardfloat': {
+        'CPPDEFINES':    ['__mips_hard_float=1'],
+      }
     },
     'arch:x64': {
       'CPPDEFINES':   ['V8_TARGET_ARCH_X64'],
@@ -236,12 +213,15 @@
     },
     'gdbjit:on': {
       'CPPDEFINES':   ['ENABLE_GDB_JIT_INTERFACE']
+    },
+    'compress_startup_data:bz2': {
+      'CPPDEFINES':   ['COMPRESS_STARTUP_DATA_BZ2']
     }
   },
   'msvc': {
     'all': {
       'CCFLAGS':      ['$DIALECTFLAGS', '$WARNINGFLAGS'],
-      'CXXFLAGS':     ['$CCFLAGS', '/GR-', '/Gy'],
+      'CXXFLAGS':     ['/GR-', '/Gy'],
       'CPPDEFINES':   ['WIN32'],
       'LINKFLAGS':    ['/INCREMENTAL:NO', '/NXCOMPAT', '/IGNORE:4221'],
       'CCPDBFLAGS':   ['/Zi']
@@ -321,6 +301,11 @@
     'os:macos': {
       'WARNINGFLAGS': ['-pedantic']
     },
+    'arch:arm': {
+      # This is to silence warnings about ABI changes that some versions of the
+      # CodeSourcery G++ tool chain produce for each occurrence of varargs.
+      'WARNINGFLAGS': ['-Wno-abi']
+    },
     'disassembler:on': {
       'CPPDEFINES':   ['ENABLE_DISASSEMBLER']
     }
@@ -341,6 +326,9 @@
     },
     'arch:mips': {
       'CPPDEFINES':   ['V8_TARGET_ARCH_MIPS'],
+      'mips_arch_variant:mips32r2': {
+        'CPPDEFINES':    ['_MIPS_ARCH_MIPS32R2']
+      },
     },
     'disassembler:on': {
       'CPPDEFINES':   ['ENABLE_DISASSEMBLER']
@@ -365,3 +353,67 @@
       'LINKFLAGS': ['-mt']
     },
     'os:openbsd': {
+      'LIBS': ['execinfo', 'pthread']
+    },
+    'os:win32': {
+      'LIBS': ['winmm', 'ws2_32'],
+    },
+    'compress_startup_data:bz2': {
+      'os:linux': {
+        'LIBS': ['bz2']
+      }
+    },
+  },
+  'msvc': {
+    'all': {
+      'CPPDEFINES': ['_HAS_EXCEPTIONS=0'],
+      'LIBS': ['winmm', 'ws2_32']
+    }
+  }
+}
+
+
+DTOA_EXTRA_FLAGS = {
+  'gcc': {
+    'all': {
+      'WARNINGFLAGS': ['-Werror', '-Wno-uninitialized'],
+      'CCFLAGS': GCC_DTOA_EXTRA_CCFLAGS
+    }
+  },
+  'msvc': {
+    'all': {
+      'WARNINGFLAGS': ['/WX', '/wd4018', '/wd4244']
+    }
+  }
+}
+
+
+CCTEST_EXTRA_FLAGS = {
+  'all': {
+    'CPPPATH': [join(root_dir, 'src')],
+    'library:shared': {
+      'CPPDEFINES': ['USING_V8_SHARED']
+    },
+  },
+  'gcc': {
+    'all': {
+      'LIBPATH':      [abspath('.')],
+      'CCFLAGS':      ['$DIALECTFLAGS', '$WARNINGFLAGS'],
+      'CXXFLAGS':     ['-fno-rtti', '-fno-exceptions'],
+      'LINKFLAGS':    ['$CCFLAGS'],
+    },
+    'os:linux': {
+      'LIBS':         ['pthread'],
+      'CCFLAGS':      ['-Wno-unused-but-set-variable'],
+    },
+    'os:macos': {
+      'LIBS':         ['pthread'],
+    },
+    'os:freebsd': {
+      'LIBS':         ['execinfo', 'pthread']
+    },
+    'os:solaris': {
+      'LIBS':         ['m', 'pthread', 'socket', 'nsl', 'rt'],
+      'LINKFLAGS':    ['-mt']
+    },
+    'os:openbsd': {

=== debian/changelog ===
libv8 (3.4.14.21-5) unstable; urgency=low

  [ Jakub Wilk ]
  * Add patch (taken from upstream VCS) to fix compatibility with ICU 4.8
    Closes: bug#648506.
    Thanks to Julien Cristau for the bug report.

 -- Jérémy Lal <kapouer@melix.org>  Tue, 15 Nov 2011 23:07:20 +0100

libv8 (3.4.14.21-4) unstable; urgency=low

  * Fix armel tests. Closes: bug#644163.
    Thanks to Vyacheslav Egorov. 

 -- Jérémy Lal <kapouer@melix.org>  Fri, 21 Oct 2011 16:24:05 +0200

libv8 (3.4.14.21-3) unstable; urgency=low

  * Disable VFP for armel
  * Disable unaligned access for armel

 -- Jérémy Lal <kapouer@melix.org>  Wed, 28 Sep 2011 23:14:48 +0200

libv8 (3.4.14.21-2) unstable; urgency=low

  [ Jonas Smedegaard ]
  * Rewrite short and long descriptions. Closes: bug#624374.
    Thanks to Erik Esterer.

  [ Jérémy Lal ]
  * Redirect output of mksnapshot to stdout. This helps armel debugging.
  * Backport of fix for upstream issue#1706: unaligned access on armel.

 -- Jérémy Lal <kapouer@melix.org>  Wed, 28 Sep 2011 11:25:48 +0200

libv8 (3.4.14.21-1) unstable; urgency=low

  [ Jérémy Lal ]
  * New upstream release.
  * Adds -mno-thumb-interwork on armel (armeabi:softfp).
    Upstream does not support thumb interworking < armv5t.
    However it is supported on armhf.
  * Move compiler flags for arm in debian/rules, instead of setting
    them using a quilt patch.
  * Relax build-dependencies on cdbs (unneededly tight) and debhelper
    (needed version satisfied even in oldstable).
  * Tests timeout after 120 seconds, instead of 60.
    Some builders can have slower machines.

  [ Jonas Smedegaard ]
  * Update watch file: Track 3.4.x releases.
  * Relax build-dependency on devscripts (needed version satisfied even
    in oldstable).
  * Update copyright file:
    + Fix use Source: (not Upstream-Source:).
    + Newline-delimit file list.
    + Use ~ as indicator for derived licenses.
    + Shorten license comment, and quote license name.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 17 Sep 2011 16:55:28 +0200

libv8 (3.4.14.13-4) experimental; urgency=low

  * Export I18NExtension::get and I18NExtension::Register.
    Closes: bug#639596.

 -- Jérémy Lal <kapouer@melix.org>  Sun, 04 Sep 2011 15:41:48 +0200

libv8 (3.4.14.13-3) experimental; urgency=low

  * move I18NExtension from v8::internal to v8_i18n namespace,
    following the externalization of i18n extension in chromium 15.
    Closes: bug#639596.

 -- Jérémy Lal <kapouer@melix.org>  Sun, 04 Sep 2011 10:35:09 +0200

libv8 (3.4.14.13-2) experimental; urgency=low

  * fix include of "v8.h" in i18n-extension.h
    Closes: bug#639522. Thanks to Giuseppe Iuculano.

 -- Jérémy Lal <kapouer@melix.org>  Sun, 28 Aug 2011 00:15:25 +0200

libv8 (3.4.14.13-1) experimental; urgency=low

  * New upstream release.

  [ Jérémy Lal ]
  * Bump version in debian/control (and debian/control.in)

  [ Jonas Smedegaard ]
  * Add patch 0007 to fix armhf.
    Closes: bug#636370. Thanks to Konstantinos Margaritis.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 24 Aug 2011 01:21:27 +0200

libv8 (3.4.14-1) experimental; urgency=low

  * New upstream release.

  [ Jérémy Lal ]
  * mipsel architecture added.
  * Fix FTBFS with gcc 4.6 using -Wnounused-but-set-variable.
    Closes: bug#625377.
  * Enable i18n experimental extension: reworked, could be broken.
  * Unfuzz patches.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 23 Jul 2011 01:14:22 +0200

=== debian/control ===
Source: libv8
Priority: optional
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Jérémy Lal <kapouer@melix.org>,
 Jonas Smedegaard <dr@jones.dk>
Build-Depends: devscripts,
 cdbs (>= 0.4.73~),
 scons,
 debhelper,
 dh-buildinfo, libicu-dev
Standards-Version: 3.9.2
Section: libs
Homepage: http://code.google.com/p/v8/
DM-Upload-Allowed: yes
Vcs-Browser: http://git.debian.org/?p=collab-maint/libv8.git
Vcs-Git: git://git.debian.org/git/collab-maint/libv8.git

Package: libv8-dev
Section: libdevel
Architecture: i386 amd64 armel armhf mipsel
Depends: libv8-3.4.14.21 (= ${binary:Version}), ${misc:Depends}
Description: v8 JavaScript engine - development files
 V8 is a high performance JavaScript engine written in C++.  It is used
 in the web browser Chromium.
 .
 Install this package if you wish to develop your own programs using the
 v8 JavaScript engine.

Package: libv8-3.4.14.21
Architecture: i386 amd64 armel armhf mipsel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: v8 JavaScript engine - runtime library
 V8 is a high performance JavaScript engine written in C++.  It is used
 in the web browser Chromium.
 .
 This package includes the dynamic library against which you can link
 your program.

Package: libv8-dbg
Priority: extra
Section: debug
Architecture: i386 amd64 armel armhf mipsel
Depends: libv8-3.4.14.21 (= ${binary:Version}), ${misc:Depends}
Description: v8 JavaScript engine - debugging symbols
 V8 is a high performance JavaScript engine written in C++.  It is used
 in the web browser Chromium.
 .
 This package provides the debugging symbols for the library.

=== debian/rules ===
--- 
+++ 
@@ -18,11 +18,6 @@
 
 DEB_DH_MAKESHLIBS_ARGS = -- -c4
 
-CXXFLAGS += -fno-strict-aliasing -Wno-error=unused-but-set-variable
-CFLAGS += -fno-strict-aliasing -Wno-error=unused-but-set-variable
-export CFLAGS
-export CXXFLAGS
-
 # map HOST ARCH AND OS to v8 options
 v8arch := $(or $(v8arch),$(if $(filter i386,$(DEB_HOST_ARCH)),ia32))
 v8arch := $(or $(v8arch),$(if $(filter amd64,$(DEB_HOST_ARCH)),x64))
@@ -34,13 +29,38 @@
 v8os := $(or $(v8os),$(if $(filter kfreebsd,$(DEB_HOST_ARCH_OS)),freebsd))
 v8os := $(or $(v8os),$(DEB_HOST_ARCH_OS))
 
-DEB_SCONS_OPTIONS = library=shared soname=on snapshot=on shlibtype=hidden arch=$(v8arch) os=$(v8os)
+# force aligned access
+v8armunaligned :=
+# armel and armhf arches need flags to work around those issues :
+# -fno-tree-sink: http://gcc.gnu.org/bugzilla/show_bug.cgi?id=39604
+# -Wno-psabi: http://gcc.gnu.org/bugzilla/show_bug.cgi?id=42748
+v8armeabi := soft
+# armhf is hardfloat
+ifeq (armhf, $(DEB_HOST_ARCH))
+v8armeabi := hard
+CCFLAGS += -fno-tree-sink
+CXXFLAGS += -Wno-psabi
+endif
+
+ifeq (armel, $(DEB_HOST_ARCH))
+v8armunaligned := unalignedaccesses=off
+CCFLAGS += -fno-tree-sink
+CXXFLAGS += -Wno-psabi
+# Disable thumb-interworking because v8 supports it only on >= armv5t.
+# http://code.google.com/p/v8/issues/detail?id=590
+CCFLAGS += -mno-thumb-interwork
+endif
+
+export CCFLAGS
+export CXXFLAGS
+
+DEB_SCONS_OPTIONS = library=shared soname=on snapshot=on shlibtype=hidden arch=$(v8arch) os=$(v8os) armeabi=$(v8armeabi) $(v8armunaligned)
 DEB_SCONS_BUILD_TARGET = library
 
 # Scons does not always add -soname param, force it. This prevents gold linker from erroring.
 DEB_SCONS_ENVVARS = SONAME=libv8.so.$(SONAME)
 
-# regression tests need to build shell for mjsunit
+# regression tests need to build shell for mjsunit -- will be deprecated in 3.5 branch in favor of d8. shell becoming a simple v8 cli.
 DEB_SCONS_CHECK_TARGET = sample sample=shell
 
 DEB_SCONS_INSTALL_OPTIONS += DESTDIR="$(cdbs_curdestdir)"

=== debian/watch ===
--- 
+++ 
@@ -5,4 +5,4 @@
 # SVN tag but the watch file will still useful to find
 # new versions
 opts="dversionmangle=s/\+dfsg//" \
-http://v8.googlecode.com/svn/tags/ (3\.1\.[\d.]+)/
+http://v8.googlecode.com/svn/tags/ (3\.4\.[\d.]+)/
